<template>
    <div>
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in selectTagMenus"
                            :key="index"
                            :value="menu.title"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Title"
                rules="required"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Title</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.title_popup"
                        type="text"
                        name="title_popup"
                        :state="getValidationState(validationContext)"
                        class="my-input full-width"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Description"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Description</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.text_popup"
                        type="text"
                        class="my-input full-width"
                        name="text_popup"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Allow Button Text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Allow Button Text</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.allow_button_text"
                        type="text"
                        class="my-input full-width"
                        name="allow_button_text"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Disallow Button Text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Disallow Button Text</b>
                    </div>
                    <b-form-input
                        v-model="textEditor.disallow_button_text"
                        type="text"
                        class="my-input full-width"
                        name="disallow_button_text"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                    />
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Email Content</b>
                </div>
            </div>
            <div class="row">
                <div class="col-md-4">
                    <validation-provider
                        v-slot="validationContext"
                        name="Delay"
                        :rules="{ required: true }"
                    >
                        <b-form-group class="full-width">
                            <div class="form-content-title">
                                <b>Delay</b>
                            </div>
                            <div class="delay-container">
                                <b-form-input
                                    v-model="textEditor.delay"
                                    type="number"
                                    class="my-input full-width"
                                    name="delay"
                                />
                                <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                                <span>Seconds</span>
                            </div>
                        </b-form-group>
                    </validation-provider>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: "TextEditor",
    props: ['textEditor'],
    data: () => ({
        selectTagMenus: [
            {
                title: 'tags'
            },
            {
                title: '{siteName}'
            },
            {
                title: '{storeEmail}'
            },
            {
                title: '{discountValue}'
            },
        ],
        selectedTagMenu: 'tags',
        focusedInput: 0,
        focusedName: '',
    }),
    methods: {
        addText() {
            const len = this.textEditor[this.focusedName].length
            const before = this.textEditor[this.focusedName].substr(0, this.focusedInput)
            const after = this.textEditor[this.focusedName].substr(this.focusedInput, len)
            this.textEditor[this.focusedName] = before + this.selectedTagMenu + after
            this.focusedInput += this.selectedTagMenu.length
            this.selectedTagMenu = 'tags'
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },

        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
    }
}
</script>

<style scoped lang="scss">

.delay-container {
    display: flex;
    align-items: center;
    span {
        margin-left: 10px;
    }
}

.form-content-title {
    margin-top: 0;
}

</style>
